## ros-noetic-ueye-cam 1.0.19

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)

project(ueye_cam)

# C++11 Needed
include(CheckCXXCompilerFlag)

CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)

if(COMPILER_SUPPORTS_CXX11)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
elseif(COMPILER_SUPPORTS_CXX0X)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
else()
    message(FATAL_ERROR "The compiler ${CMAKE_CXX_COMPILER} has no C++11 support. Please use a different C++ compiler.")
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -g")

find_package(catkin REQUIRED COMPONENTS
  roscpp
  nodelet
  dynamic_reconfigure
  image_transport
  sensor_msgs
  camera_calibration_parsers
  camera_info_manager
  )
catkin_destinations() # define ${CATKIN_PACKAGE_SHARE_DESTINATION}

#set(UEYE_LIBRARY_PATH /usr/lib)
find_library(UEYE_LIBRARY ueye_api)
set(USE_UNOFFICIAL_UEYE_DRIVERS FALSE)
if(NOT UEYE_LIBRARY)
  message(STATUS "libueye_api was not found in system's library path")
  #include(cmake_modules/DownloadUEyeDrivers.cmake)
  include(cmake_modules/DownloadUEyeDriversUnofficial.cmake)
  set(UEYE_DRIVER_DIR ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION})
  if(UEYE_DRIVER_DIR)
    message(STATUS "Setting UEYE_DRIVER_DIR to: ${UEYE_DRIVER_DIR}")
  else()
    set(UEYE_DRIVER_DIR ${CMAKE_CURRENT_BINARY_DIR})
    message(STATUS "Failed to set UEYE_DRIVER_DIR to: CATKIN_DEVEL_PREFIX/CATKIN_PACKAGE_SHARE_DESTINATION, defaulting to CMAKE_CURRENT_BINARY_DIR: ${UEYE_DRIVER_DIR}")
  endif()
  download_ueye_drivers(UEYE_LIBRARY UEYE_INCLUDE_DIR ${UEYE_DRIVER_DIR})
  message(STATUS "libueye_api library: ${UEYE_LIBRARY}")
  message(STATUS "libueye_api include: ${UEYE_INCLUDE_DIR}")
  set(USE_UNOFFICIAL_UEYE_DRIVERS TRUE)
endif()

set(UEYECAM_NODELET_NAME ueye_cam_nodelet)
set(UEYECAM_LIB_NAME ueye_wrapper)

set(UEYECAM_LIB_SOURCES
  src/ueye_cam_driver.cpp
)

set(UEYECAM_LIB_HEADERS
  include/ueye_cam/logging_macros.hpp
  include/ueye_cam/ueye_cam_driver.hpp
)

set(UEYECAM_NODELET_SOURCES
  src/ueye_cam_nodelet.cpp
)

set(UEYECAM_NODELET_HEADERS
  include/ueye_cam/ueye_cam_nodelet.hpp
)

generate_dynamic_reconfigure_options(
  cfg/UEyeCam.cfg
  )

catkin_package(
  INCLUDE_DIRS include
  LIBRARIES ${UEYECAM_LIB_NAME} ${UEYECAM_NODELET_NAME}
  CATKIN_DEPENDS roscpp nodelet dynamic_reconfigure image_transport sensor_msgs camera_calibration_parsers camera_info_manager
  )

include_directories(
  include
  ${catkin_INCLUDE_DIRS}
  ${UEYE_INCLUDE_DIR}
  )


add_library(${UEYECAM_LIB_NAME} ${UEYECAM_LIB_SOURCES} ${UEYECAM_LIB_HEADERS})
target_link_libraries(${UEYECAM_LIB_NAME} ${catkin_LIBRARIES} ${UEYE_LIBRARY})

add_library(${UEYECAM_NODELET_NAME} ${UEYECAM_NODELET_SOURCES} ${UEYECAM_NODELET_HEADERS})
target_link_libraries(${UEYECAM_NODELET_NAME} ${catkin_LIBRARIES} ${UEYECAM_LIB_NAME})
add_dependencies(${UEYECAM_NODELET_NAME} ${PROJECT_NAME}_gencfg)

add_executable(check_ueye_api src/check_ueye_api.cpp)
target_link_libraries(check_ueye_api ${catkin_LIBRARIES})

# Do not package the barebones IDS drivers, since they will mask over the official drivers (when present)
#if(USE_UNOFFICIAL_UEYE_DRIVERS)
#  get_filename_component(UNOFFICIAL_UEYE_DRIVERS_LIB_REALPATH ${UEYE_LIBRARY} REALPATH)
#  install(FILES ${UEYE_LIBRARY} ${UNOFFICIAL_UEYE_DRIVERS_LIB_REALPATH}
#    DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})
#endif()

# Mark cpp header files for installation
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
  PATTERN ".svn" EXCLUDE
)

install(TARGETS ${UEYECAM_LIB_NAME} ${UEYECAM_NODELET_NAME} check_ueye_api
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
  )

install(FILES nodelet_plugins.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
  )

install(DIRECTORY launch/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch
  )

=== debian/changelog ===
ros-noetic-ueye-cam (1.0.19-1focal) focal; urgency=high

  * updated MD5 hash for re-packaged unofficiall IDS drivers archives
  * Contributors: Anqi Xu

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Wed, 13 Jan 2021 05:00:00 -0000

ros-noetic-ueye-cam (1.0.18-1focal) focal; urgency=high

  * updated driver URLs for 4.94 version
  * [uEye 4.94] Update Deprecated Event Handling Functions  (#97 <https://github.com/anqixu/ueye_cam/issues/97>)
    * Updated event functions to 4.94 API + Added init of event before enabling it
    * Added uEye 4.94 req
    * Changed timeout to UINT to fit 4_94 API
  * Adding call of exit routine for the frame event
  * Adding auto exposure reference value
  * Added support for setting the software-gamma
  * Package format update and code cleanup
  * Contributors: Anqi Xu, Brett Newman, Nullket, jmackay2, nullket

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Sat, 09 Jan 2021 05:00:00 -0000

ros-noetic-ueye-cam (1.0.17-1focal) focal; urgency=high

  * Merge pull request #83 <https://github.com/anqixu/ueye_cam/issues/83> from anqixu/use_ros_time
    Do not get timestamp from camera, and use ros::Time::now() instead
  * Merge pull request #61 <https://github.com/anqixu/ueye_cam/issues/61> from jackokaiser/master
    Adapted roslaunch for passing camera name as argument
  * Changes from https://github.com/anqixu/ueye_cam/issues/82
  * Do not link the ueye api to the check api node to avoid conflicts
  * Default dynamic_reconfigure parameters now don't overwrite ini file params.
    Fixes #74 <https://github.com/anqixu/ueye_cam/issues/74>
  * image dimensions now account for cam_subsampling_rate
  * Merge pull request #65 <https://github.com/anqixu/ueye_cam/issues/65> from flynneva/dev
  * removed / from frame_ID so that data can be used with new ros tf2 standard
  * Removed trailing whitespaces
  * Readded camera_conf for backward compatibility
  * changed setFlashParams failure into warning
  * Adapted roslaunch for passing camera name as argument
  * nodelet no longer dies upon setFlashParams fail (since some cameras don't support it)
  * Merge pull request #54 <https://github.com/anqixu/ueye_cam/issues/54> from 534o/master
  * forget to add check_ueye_api to install list
  * Contributors: Anqi Xu, Anup Parikh, Evan Flynn, Jacques KAISER, Tokyo Opensource Robotics Developer 534, loooph

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Wed, 26 Aug 2020 04:00:00 -0000

ros-noetic-ueye-cam (1.0.16-1focal) focal; urgency=high

  * fixed crash on camera reconnect
  * Contributors: Anqi Xu, Christopher Wecht

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Mon, 02 Jan 2017 05:00:00 -0000

ros-noetic-ueye-cam (1.0.15-1focal) focal; urgency=high

  * recover + update from failure in setColorMode
  * extended color modes (10, 12, 16 bit per channel)
  * added timeout topic for better debugging of frame timeouts
  * Contributors: Anqi Xu, Dominik Klein

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Thu, 25 Aug 2016 04:00:00 -0000

ros-noetic-ueye-cam (1.0.14-1focal) focal; urgency=high

  * now attempting to link against 32-bit ARMHF IDS libs on ARM64 arch
  * added capability to detect ARM64 processor (aarch64)
  * added separate rates for polling frames vs publishing images
  * fixed buffersize for subsampling and increased maximum image size availible via rqt
  * added Travis CI config
  * Contributors: Anqi Xu, Eddy, Isaac I.Y. Saito, francois

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Thu, 26 May 2016 04:00:00 -0000

ros-noetic-ueye-cam (1.0.13-1focal) focal; urgency=high

  * Change timestamp source based on issue https://github.com/anqixu/ueye_cam/issues/37
  * changed 'failure to set active-low flash' from error to warning
  * Fixed typo in Gain for dynamic reconfigure parameters
  * Updated pixel_clock cap in dyncfg settings
  * Added check_ueye_api to confirm availability of IDS SDK at runtime
  * Contributors: Anqi Xu, Anup, Aris Synodinos, Kei Okada

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Fri, 13 May 2016 04:00:00 -0000

ros-noetic-ueye-cam (1.0.12-1focal) focal; urgency=high

  * fixed binning IS_INVALID_BUFFER_SIZE bug
  * Modified nodelet to use camera timestamp instead of wall clock time
  * Fix for new upstream dir name on ARM
  * Contributors: Alejandro Merello, Anqi Xu, Scott K Logan

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Mon, 28 Sep 2015 04:00:00 -0000

ros-noetic-ueye-cam (1.0.11-1focal) focal; urgency=high

  * updated barebones IDS drivers to 4.61
  * removed barebones IDS drivers from debian packaging
  * Added proper checking for C++11 features on compilers
  * Performed minor code cleanup, updated old PLUGINLIB_DECLARE_CLASS to
    newer PLUGINLIB_EXPORT_CLASS
  * Contributors: Anqi Xu, Aris Synodinos

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Mon, 17 Aug 2015 04:00:00 -0000

ros-noetic-ueye-cam (1.0.10-1focal) focal; urgency=high

  * fixed setting synchronization bugs during camera initialization
  * added support for (packed) BGR8 color mode
  * failing to set non-essential parameters will no longer prematurily terminate nodelet
  * updated printouts to be more verbose and consistent
  * fix for reported ARM arch on Fedora
  * Contributors: Anqi Xu, Scott K Logan

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Thu, 06 Aug 2015 04:00:00 -0000

ros-noetic-ueye-cam (1.0.9-1focal) focal; urgency=high

  * fixed lagged changes to flip_upd and flip_lr via rqt_reconfigure
  * Support discrete-only pixelclocks cameras
  * Ask if gainboost is supported first
  * Switched to jbohren's version of the file(GENERATE...) fix
  * Contributors: Anqi Xu, Fran Real, Jonathan Bohren

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Tue, 03 Feb 2015 05:00:00 -0000

ros-noetic-ueye-cam (1.0.8-1focal) focal; urgency=high

  * switched from cmake's file(GENERATE ...) to execute_command(cp ...), to accommodate cmake 2.8.x on Saucy
  * Contributors: Anqi Xu

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Thu, 08 Jan 2015 05:00:00 -0000

ros-noetic-ueye-cam (1.0.7-1focal) focal; urgency=high

  * continuing to address issues on ROS bin buildfarm
  * Contributors: Anqi Xu



=== debian/control ===
Source: ros-noetic-ueye-cam
Section: misc
Priority: optional
Maintainer: Anqi Xu <anqixu@cim.mcgill.ca>
Build-Depends: debhelper (>= 9.0.0), ros-noetic-camera-calibration-parsers, ros-noetic-camera-info-manager, ros-noetic-catkin, ros-noetic-dynamic-reconfigure, ros-noetic-image-transport, ros-noetic-nodelet, ros-noetic-roscpp, ros-noetic-sensor-msgs
Homepage: 
Standards-Version: 3.9.2

Package: ros-noetic-ueye-cam
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-camera-calibration-parsers, ros-noetic-camera-info-manager, ros-noetic-dynamic-reconfigure, ros-noetic-image-transport, ros-noetic-nodelet, ros-noetic-roscpp, ros-noetic-sensor-msgs
Description: A ROS nodelet and node that wraps the driver API for UEye cameras by IDS Imaging Development Systems GMBH.
